--- emacs24-24.3+1.orig/lisp/progmodes/cc-cmds.el
+++ emacs24-24.3+1/lisp/progmodes/cc-cmds.el
@@ -1,32 +1,34 @@
 ;;; cc-cmds.el --- user level commands for CC Mode
 
-;; Copyright (C) 1985, 1987, 1992-2013 Free Software Foundation, Inc.
+;; Copyright (C) 1985, 1987, 1992, 1993, 1994, 1995, 1996, 1997, 1998,
+;;   1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009,
+;;   2010, 2011   Free Software Foundation, Inc.
 
 ;; Authors:    2003- Alan Mackenzie
-;;             1998- Martin Stjernholm
-;;             1992-1999 Barry A. Warsaw
-;;             1987 Dave Detlefs
-;;             1987 Stewart Clamen
-;;             1985 Richard M. Stallman
+;;	       1998- Martin Stjernholm
+;;	       1992-1999 Barry A. Warsaw
+;;	       1987 Dave Detlefs and Stewart Clamen
+;;	       1985 Richard M. Stallman
 ;; Maintainer: bug-cc-mode@gnu.org
 ;; Created:    22-Apr-1997 (split from cc-mode.el)
-;; Keywords:   c languages
-;; Package:    cc-mode
+;; Version:    See cc-mode.el
+;; Keywords:   c languages oop
 
 ;; This file is part of GNU Emacs.
 
-;; GNU Emacs is free software: you can redistribute it and/or modify
+;; GNU Emacs is free software; you can redistribute it and/or modify
 ;; it under the terms of the GNU General Public License as published by
-;; the Free Software Foundation, either version 3 of the License, or
-;; (at your option) any later version.
+;; the Free Software Foundation; either version 3, or (at your option)
+;; any later version.
 
 ;; GNU Emacs is distributed in the hope that it will be useful,
 ;; but WITHOUT ANY WARRANTY; without even the implied warranty of
-;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
 ;; GNU General Public License for more details.
 
 ;; You should have received a copy of the GNU General Public License
-;; along with GNU Emacs.  If not, see <http://www.gnu.org/licenses/>.
+;; along with this program; see the file COPYING.  If not, see
+;; <http://www.gnu.org/licenses/>.
 
 ;;; Commentary:
 
@@ -48,6 +50,8 @@
 (cc-bytecomp-defun delete-forward-p)	; XEmacs
 (cc-bytecomp-defvar filladapt-mode)	; c-fill-paragraph contains a kludge
 					; which looks at this.
+(cc-bytecomp-defun c-forward-subword)
+(cc-bytecomp-defun c-backward-subword)
 
 ;; Indentation / Display syntax functions
 (defvar c-fix-backslashes t)
@@ -57,10 +61,10 @@
 if `c-syntactic-indentation' is non-nil.  Optional SYNTAX is the
 syntactic information for the current line.  Be silent about syntactic
 errors if the optional argument QUIET is non-nil, even if
-`c-report-syntactic-errors' is non-nil.  Normally the position of
+`c-report-syntactic-errors' is non-nil.	 Normally the position of
 point is used to decide where the old indentation is on a lines that
 is otherwise empty \(ignoring any line continuation backslash), but
-that's not done if IGNORE-POINT-POS is non-nil.  Returns the amount of
+that's not done if IGNORE-POINT-POS is non-nil.	 Returns the amount of
 indentation change \(in columns)."
 
   (let ((line-cont-backslash (save-excursion
@@ -143,7 +147,7 @@ and takes care to set the indentation be
   (let ((c-macro-start (c-query-macro-start))
 	;; Avoid calling c-backslash-region from c-indent-line if it's
 	;; called during the newline call, which can happen due to
-	;; c-electric-continued-statement, for example.  We also don't
+	;; c-electric-continued-statement, for example.	 We also don't
 	;; want any backslash alignment from indent-according-to-mode.
 	(c-fix-backslashes nil)
 	has-backslash insert-backslash
@@ -186,7 +190,7 @@ and takes care to set the indentation be
       (let ((c-syntactic-context (c-save-buffer-state nil
 				   (c-guess-basic-syntax))))
 	;; We temporarily insert another line break, so that the
-	;; lineup functions will see the line as empty.  That makes
+	;; lineup functions will see the line as empty.	 That makes
 	;; e.g. c-lineup-cpp-define more intuitive since it then
 	;; proceeds to the preceding line in this case.
 	(insert ?\n)
@@ -199,7 +203,7 @@ and takes care to set the indentation be
 	  (goto-char (- (point-max) start))
 	  (delete-char -1)))
       (when has-backslash
-	;; Must align the backslash again after reindentation.  The
+	;; Must align the backslash again after reindentation.	The
 	;; c-backslash-region call above can't be optimized to ignore
 	;; this line, since it then won't align correctly with the
 	;; lines below if the first line in the macro is broken.
@@ -259,19 +263,17 @@ With universal argument, inserts the ana
 			 "a" "")
 		     (if c-hungry-delete-key "h" "")
 		     (if (and
-			  ;; subword might not be loaded.
-			  (boundp 'subword-mode)
-			  (symbol-value 'subword-mode))
+			  ;; cc-subword might not be loaded.
+			  (boundp 'c-subword-mode)
+			  (symbol-value 'c-subword-mode))
 			 "w"
 		       "")))
-        ;; FIXME: Derived modes might want to use something else
-        ;; than a string for `mode-name'.
 	(bare-mode-name (if (string-match "\\(^[^/]*\\)/" mode-name)
-			    (match-string 1 mode-name)
+			    (substring mode-name (match-beginning 1) (match-end 1))
 			  mode-name)))
 ;;     (setq c-submode-indicators
-;; 	  (if (> (length fmt) 1)
-;; 	      fmt))
+;;	  (if (> (length fmt) 1)
+;;	      fmt))
     (setq mode-name
 	  (if (> (length fmt) 1)
 	      (concat bare-mode-name fmt)
@@ -291,7 +293,7 @@ context keys, when applicable.
 When it's turned off, the electric keys don't reindent, the indentation
 functions indents every new line to the same level as the previous
 nonempty line, and \\[c-indent-command] adjusts the indentation in steps
-specified by `c-basic-offset'.  The indentation style has no effect in
+specified by `c-basic-offset'.	The indentation style has no effect in
 this mode, nor any of the indentation associated variables,
 e.g. `c-special-indent-hook'.
 
@@ -310,7 +312,7 @@ left out.
 Turning on auto-newline automatically enables electric indentation.
 
 When the auto-newline feature is enabled (indicated by \"/la\" on the
-mode line after the mode name) newlines are automatically inserted
+modeline after the mode name) newlines are automatically inserted
 after special characters such as brace, comma, semi-colon, and colon."
   (interactive "P")
   (setq c-auto-newline
@@ -320,7 +322,7 @@ after special characters such as brace,
   (c-keep-region-active))
 
 (defalias 'c-toggle-auto-state 'c-toggle-auto-newline)
-(make-obsolete 'c-toggle-auto-state 'c-toggle-auto-newline "22.1")
+(make-obsolete 'c-toggle-auto-state 'c-toggle-auto-newline nil)
 
 (defun c-toggle-hungry-state (&optional arg)
   "Toggle hungry-delete-key feature.
@@ -329,7 +331,7 @@ positive, turns it off when negative, an
 left out.
 
 When the hungry-delete-key feature is enabled (indicated by \"/h\" on
-the mode line after the mode name) the delete key gobbles all preceding
+the modeline after the mode name) the delete key gobbles all preceding
 whitespace in one fell swoop."
   (interactive "P")
   (setq c-hungry-delete-key (c-calculate-state arg c-hungry-delete-key))
@@ -475,7 +477,7 @@ inside a literal or a macro, nothing spe
 	  (bolp (bolp)))
       (beginning-of-line)
       (delete-horizontal-space)
-      (insert last-command-event)
+      (insert (c-last-command-char))
       (and (not bolp)
 	   (goto-char (- (point-max) pos)))
       )))
@@ -524,7 +526,7 @@ inside a literal or a macro, nothing spe
 	;; This is the list of brace syntactic symbols that can hang.
 	;; If any new ones are added to c-offsets-alist, they should be
 	;; added here as well.
-	;;
+	;; 
 	;; The order of this list is important; if SYNTAX has several
 	;; elements, the element that "wins" is the earliest in SYMS.
 	'(arglist-cont-nonempty		; e.g. an array literal.
@@ -540,7 +542,7 @@ inside a literal or a macro, nothing spe
 		     composition-open composition-close
 		     inexpr-class-open inexpr-class-close
 		     ;; `statement-cont' is here for the case with a brace
-		     ;; list opener inside a statement.  C.f. CASE B.2 in
+		     ;; list opener inside a statement.	 C.f. CASE B.2 in
 		     ;; `c-guess-continued-construct'.
 		     statement-cont))
        ;; shut this up too
@@ -645,7 +647,7 @@ inside a literal or a macro, nothing spe
 	      (insert-char ?\} 1)	; reinsert the `}' before the comment.
 	      (setq cmnt-gap (- cmnt-col (current-column)))
 	      (when (zerop cmnt-gap)
-		(insert-char ?\  1)	; Put a space before a bare comment.
+		(insert-char ?\	 1)	; Put a space before a bare comment.
 		(setq cmnt-gap 1)))
 
 	    (or (null c-max-one-liner-length)
@@ -737,7 +739,7 @@ settings of `c-cleanup-list' are done."
 	      ;; `}': clean up empty defun braces
 	      (when (c-save-buffer-state ()
 		      (and (memq 'empty-defun-braces c-cleanup-list)
-			   (eq last-command-event ?\})
+			   (eq (c-last-command-char) ?\})
 			   (c-intersect-lists '(defun-close class-close inline-close)
 					      syntax)
 			   (progn
@@ -753,14 +755,14 @@ settings of `c-cleanup-list' are done."
 	      ;; `}': compact to a one-liner defun?
 	      (save-match-data
 		(when
-		    (and (eq last-command-event ?\})
+		    (and (eq (c-last-command-char) ?\})
 			 (memq 'one-liner-defun c-cleanup-list)
 			 (c-intersect-lists '(defun-close) syntax)
 			 (c-try-one-liner))
 		  (setq here (- (point-max) pos))))
 
 	      ;; `{': clean up brace-else-brace and brace-elseif-brace
-	      (when (eq last-command-event ?\{)
+	      (when (eq (c-last-command-char) ?\{)
 		(cond
 		 ((and (memq 'brace-else-brace c-cleanup-list)
 		       (re-search-backward
@@ -814,7 +816,7 @@ settings of `c-cleanup-list' are done."
 	    ))))
 
     ;; blink the paren
-    (and (eq last-command-event ?\})
+    (and (eq (c-last-command-char) ?\})
 	 (not executing-kbd-macro)
 	 old-blink-paren
 	 (save-excursion
@@ -851,7 +853,7 @@ is inhibited."
     (when (and (not arg)
 	       (eq literal 'c)
 	       (memq 'comment-close-slash c-cleanup-list)
-	       (eq last-command-event ?/)
+	       (eq (c-last-command-char) ?/)
 	       (looking-at (concat "[ \t]*\\("
 				   (regexp-quote comment-end) "\\)?$"))
 	; (eq c-block-comment-ender "*/") ; C-style comments ALWAYS end in */
@@ -867,7 +869,7 @@ is inhibited."
     (setq indentp (and (not arg)
 		       c-syntactic-indentation
 		       c-electric-flag
-		       (eq last-command-event ?/)
+		       (eq (c-last-command-char) ?/)
 		       (eq (char-before) (if literal ?* ?/))))
     (self-insert-command (prefix-numeric-value arg))
     (if indentp
@@ -935,16 +937,23 @@ settings of `c-cleanup-list'."
 	;; do all cleanups and newline insertions if c-auto-newline is on.
 	(if (or (not c-auto-newline)
 		(not (looking-at "[ \t]*\\\\?$")))
-	    (if c-syntactic-indentation
-		(c-indent-line))
+	    (when c-syntactic-indentation
+		(let ((syntax (c-guess-basic-syntax)))
+		  (c-indent-line syntax)
+		  ;; Guard against the C hacker inserting a statement before a
+		  ;; non-compound statement in an if/while/for.
+		  (if (eq (caar syntax) 'substatement)
+		      (save-excursion
+			(if (eq 0 (forward-line))
+			    (c-indent-line))))))
 	  ;; clean ups: list-close-comma or defun-close-semi
 	  (let ((pos (- (point-max) (point))))
 	    (if (c-save-buffer-state ()
 		  (and (or (and
-			    (eq last-command-event ?,)
+			    (eq (c-last-command-char) ?,)
 			    (memq 'list-close-comma c-cleanup-list))
 			   (and
-			    (eq last-command-event ?\;)
+			    (eq (c-last-command-char) ?\;)
 			    (memq 'defun-close-semi c-cleanup-list)))
 		       (progn
 			 (forward-char -1)
@@ -1045,7 +1054,7 @@ reindented unless `c-syntactic-indentati
 		  (setcar (car elem) 'label))
 	      (setq elem (cdr elem)))
 	    ;; some language elements can only be determined by checking
-	    ;; the following line.  Let's first look for ones that can be
+	    ;; the following line.  Lets first look for ones that can be
 	    ;; found when looking on the line with the colon
 	    (setq newlines
 		  (and c-auto-newline
@@ -1089,7 +1098,7 @@ numeric argument is supplied, or the poi
 
   (interactive "*P")
   (let ((c-echo-syntactic-information-p nil)
-	final-pos close-paren-inserted found-delim case-fold-search)
+	final-pos found-delim case-fold-search)
 
     (self-insert-command (prefix-numeric-value arg))
     (setq final-pos (point))
@@ -1101,7 +1110,7 @@ numeric argument is supplied, or the poi
     ;; Indent the line if appropriate.
     (when (and c-electric-flag c-syntactic-indentation c-recognize-<>-arglists)
       (setq found-delim
-	    (if (eq last-command-event ?<)
+	    (if (eq (c-last-command-char) ?<)
 		;; If a <, basically see if it's got "template" before it .....
 		(or (and (progn
 			   (backward-char)
@@ -1195,7 +1204,7 @@ newline cleanups are done if appropriate
 	    ;; clean up brace-elseif-brace
 	    (when
 		(and (memq 'brace-elseif-brace c-cleanup-list)
-		     (eq last-command-event ?\()
+		     (eq (c-last-command-char) ?\()
 		     (re-search-backward
 		      (concat "}"
 			      "\\([ \t\n]\\|\\\\\n\\)*"
@@ -1213,7 +1222,7 @@ newline cleanups are done if appropriate
 	    ;; clean up brace-catch-brace
 	    (when
 		(and (memq 'brace-catch-brace c-cleanup-list)
-		     (eq last-command-event ?\()
+		     (eq (c-last-command-char) ?\()
 		     (re-search-backward
 		      (concat "}"
 			      "\\([ \t\n]\\|\\\\\n\\)*"
@@ -1234,16 +1243,16 @@ newline cleanups are done if appropriate
 
 	     ;; space-before-funcall clean-up?
 	     ((and (memq 'space-before-funcall c-cleanup-list)
-		   (eq last-command-event ?\()
+		   (eq (c-last-command-char) ?\()
 		   (save-excursion
 		     (backward-char)
 		     (skip-chars-backward " \t")
 		     (setq beg (point))
 		     (and (c-save-buffer-state () (c-on-identifier))
-                          ;; Don't add a space into #define FOO()....
-                          (not (and (c-beginning-of-macro)
-                                    (c-forward-over-cpp-define-id)
-                                    (eq (point) beg))))))
+			  ;; Don't add a space into #define FOO()....
+			  (not (and (c-beginning-of-macro)
+				    (c-forward-over-cpp-define-id)
+				    (eq (point) beg))))))
 	      (save-excursion
 		(delete-region beg end)
 		(goto-char beg)
@@ -1252,7 +1261,7 @@ newline cleanups are done if appropriate
 	     ;; compact-empty-funcall clean-up?
 		  ((c-save-buffer-state ()
 		     (and (memq 'compact-empty-funcall c-cleanup-list)
-			  (eq last-command-event ?\))
+			  (eq (c-last-command-char) ?\))
 			  (save-excursion
 			    (c-safe (backward-char 2))
 			    (when (looking-at "()")
@@ -1281,7 +1290,7 @@ keyword on the line, the keyword is not
     (when (c-save-buffer-state ()
 	    (and c-electric-flag
 		 c-syntactic-indentation
-		 (not (eq last-command-event ?_))
+		 (not (eq (c-last-command-char) ?_))
 		 (= (save-excursion
 		      (skip-syntax-backward "w")
 		      (point))
@@ -1298,24 +1307,20 @@ keyword on the line, the keyword is not
 	(delete-char -2)))))
 
 
-
-(declare-function subword-forward "subword" (&optional arg))
-(declare-function subword-backward "subword" (&optional arg))
-
 ;; "nomenclature" functions + c-scope-operator.
 (defun c-forward-into-nomenclature (&optional arg)
   "Compatibility alias for `c-forward-subword'."
   (interactive "p")
-  (require 'subword)
-  (subword-forward arg))
-(make-obsolete 'c-forward-into-nomenclature 'subword-forward "23.2")
+  (require 'cc-subword)
+  (c-forward-subword arg))
+(make-obsolete 'c-forward-into-nomenclature 'c-forward-subword nil)
 
 (defun c-backward-into-nomenclature (&optional arg)
   "Compatibility alias for `c-backward-subword'."
   (interactive "p")
-  (require 'subword)
-  (subword-backward arg))
-(make-obsolete 'c-backward-into-nomenclature 'subword-backward "23.2")
+  (require 'cc-subword)
+  (c-backward-subword arg))
+(make-obsolete 'c-backward-into-nomenclature 'c-backward-subword nil)
 
 (defun c-scope-operator ()
   "Insert a double colon scope operator at point.
@@ -1364,19 +1369,19 @@ No indentation or other \"electric\" beh
   ;; Determine where we are with respect to functions (or other brace
   ;; constructs, included in the term "function" in the rest of this comment).
   ;; Point is assumed to be outside any macro or literal.
-  ;; This is used by c-\(beginning\|end\)-of-defun.
+  ;; This is used by c-\(begining\|end\)-of-defun.
   ;;
   ;; Return one of these symbols:
-  ;; at-header       : we're at the start of a function's header.
-  ;; in-header       : we're inside a function's header, this extending right
-  ;;                   up to the brace.  This bit includes any k&r declarations.
-  ;; in-block        : we're inside a function's brace block.
-  ;; in-trailer      : we're in the area between the "}" and ";" of something
-  ;;                  like "struct foo {...} bar, baz;".
+  ;; at-header	     : we're at the start of a function's header.
+  ;; in-header	     : we're inside a function's header, this extending right
+  ;;		       up to the brace.	 This bit includes any k&r declarations.
+  ;; in-block	     : we're inside a function's brace block.
+  ;; in-trailer	     : we're in the area between the "}" and ";" of something
+  ;;		      like "struct foo {...} bar, baz;".
   ;; at-function-end : we're just after the closing brace (or semicolon) that
-  ;;                   terminates the function.
-  ;; outwith-function: we're not at or in any function.  Being inside a
-  ;;                   non-brace construct also counts as 'outwith-function'.
+  ;;		       terminates the function.
+  ;; outwith-function: we're not at or in any function.	 Being inside a
+  ;;		       non-brace construct also counts as 'outwith-function'.
   ;;
   ;; This function might do hidden buffer changes.
   (save-excursion
@@ -1407,20 +1412,22 @@ No indentation or other \"electric\" beh
 	;; Kluge so that c-beginning-of-decl-1 won't go back if we're already
 	;; at a declaration.
 	(if (or (and (eolp) (not (eobp))) ; EOL is matched by "\\s>"
-		(not (looking-at
-"\\([;#]\\|\\'\\|\\s(\\|\\s)\\|\\s\"\\|\\s\\\\|\\s$\\|\\s<\\|\\s>\\|\\s!\\)")))
+		(not (c-looking-at-non-alphnumspace)))
 	    (forward-char))
 	(setq kluge-start (point))
 	(setq decl-result
 	      (car (c-beginning-of-decl-1
 		    ;; NOTE: If we're in a K&R region, this might be the start
 		    ;; of a parameter declaration, not the actual function.
+		    ;; It might also leave us at a label or "label" like
+		    ;; "private:".
 		    (and least-enclosing ; LIMIT for c-b-of-decl-1
 			 (c-safe-position least-enclosing paren-state)))))
 
 	;; Has the declaration we've gone back to got braces?
-	(setq brace-decl-p
-	      (save-excursion
+	(or (eq decl-result 'label)
+	    (setq brace-decl-p
+		  (save-excursion
 		    (and (c-syntactic-re-search-forward "[;{]" nil t t)
 			 (or (eq (char-before) ?\{)
 			     (and c-recognize-knr-p
@@ -1428,10 +1435,11 @@ No indentation or other \"electric\" beh
 				  ;; ';' in a K&R argdecl.  In
 				  ;; that case the declaration
 				  ;; should contain a block.
-				  (c-in-knr-argdecl))))))
+				  (c-in-knr-argdecl)))))))
 
 	(cond
-	 ((= (point) kluge-start)	; might be BOB or unbalanced parens.
+	 ((or (eq decl-result 'label)	; e.g. "private:" or invalid syntax.
+	      (= (point) kluge-start))	; might be BOB or unbalanced parens.
 	  'outwith-function)
 	 ((eq decl-result 'same)
 	  (if brace-decl-p
@@ -1567,7 +1575,7 @@ Every top level declaration that contain
 considered to be a defun.
 
 With a positive argument, move backward that many defuns.  A negative
-argument -N means move forward to the Nth following beginning.  Return
+argument -N means move forward to the Nth following beginning.	Return
 t unless search stops due to beginning or end of buffer.
 
 Unlike the built-in `beginning-of-defun' this tries to be smarter
@@ -1577,11 +1585,6 @@ defun."
   (interactive "p")
   (or arg (setq arg 1))
 
-  (or (not (eq this-command 'c-beginning-of-defun))
-      (eq last-command 'c-beginning-of-defun)
-      (and transient-mark-mode mark-active)
-      (push-mark))
-
   (c-save-buffer-state
       (beginning-of-defun-function end-of-defun-function
        (start (point))
@@ -1647,7 +1650,7 @@ defun."
 	(= arg 0)))))
 
 (defun c-forward-to-nth-EOF-} (n where)
-  ;; Skip to the closing brace of the Nth function after point.  If
+  ;; Skip to the closing brace of the Nth function after point.	 If
   ;; point is inside a function, this counts as the first.  Point must be
   ;; outside any comment/string or macro.
   ;;
@@ -1683,7 +1686,7 @@ defun."
   ;; Each time round the loop, go forward to a "}" at the outermost level.
   (while (and (> n 0) (not (eobp)))
 					;(c-parse-state)	; This call speeds up the following one by a factor
-					; of ~6.  Hmmm.  2006/4/5.
+					; of ~6.  Hmmm.	 2006/4/5.
     (when (c-syntactic-re-search-forward "{" nil 'eob)
       (backward-char)
       (forward-sexp))
@@ -1701,11 +1704,6 @@ the open-parenthesis that starts a defun
   (interactive "p")
   (or arg (setq arg 1))
 
-  (or (not (eq this-command 'c-end-of-defun))
-      (eq last-command 'c-end-of-defun)
-      (and transient-mark-mode mark-active)
-      (push-mark))
-
   (c-save-buffer-state
       (beginning-of-defun-function end-of-defun-function
        (start (point))
@@ -1747,7 +1745,7 @@ the open-parenthesis that starts a defun
 
       ;; Do we need to move forward from the brace to the semicolon?
       (when (eq arg 0)
-	(if (c-in-function-trailer-p) ; after "}" of struct/enum, etc.
+	(if (c-in-function-trailer-p)	; after "}" of struct/enum, etc.
 	    (c-syntactic-re-search-forward ";"))
 
 	(setq pos (point))
@@ -1807,9 +1805,9 @@ with a brace block."
 	      (looking-at c-symbol-key))
 	    (match-string-no-properties 0))
 
-	   ((looking-at "DEFUN\\_>")
+	   ((looking-at "DEFUN\\s-*(") ;"DEFUN\\_>") think of XEmacs!
 	    ;; DEFUN ("file-name-directory", Ffile_name_directory, Sfile_name_directory, ...) ==> Ffile_name_directory
-	    ;; DEFUN(POSIX::STREAM-LOCK, stream lockp &key BLOCK SHARED START LENGTH) ==> POSIX::STREAM-LOCK
+	    ;; DEFUN(POSIX::STREAM-LOCK, stream lockp &key BLOCK SHARED START LENGTH) ==> POSIX::STREAM-LOCK	  
 	    (down-list 1)
 	    (c-forward-syntactic-ws)
 	    (when (eq (char-after) ?\")
@@ -1819,27 +1817,9 @@ with a brace block."
 	     (point)
 	     (progn
 	       (c-forward-token-2)
-	       (when (looking-at ":")  ; CLISP: DEFUN(PACKAGE:LISP-SYMBOL,...)
-		 (skip-chars-forward "^,"))
 	       (c-backward-syntactic-ws)
 	       (point))))
-
-	   ((looking-at "DEF[a-zA-Z0-9_]* *( *\\([^, ]*\\) *,")
-	    ;; DEFCHECKER(sysconf_arg,prefix=_SC,default=, ...) ==> sysconf_arg
-	    ;; DEFFLAGSET(syslog_opt_flags,LOG_PID ...) ==> syslog_opt_flags
-	    (match-string-no-properties 1))
-
-	   ;; Objc selectors.
-	   ((assq 'objc-method-intro (c-guess-basic-syntax))
-	    (let ((bound (save-excursion (c-end-of-statement) (point)))
-		  (kw-re (concat "\\(?:" c-symbol-key "\\)?:"))
-		  (stretches))
-	      (when (c-syntactic-re-search-forward c-symbol-key bound t t t)
-		(push (match-string-no-properties 0) stretches)
-		(while (c-syntactic-re-search-forward kw-re bound t t t)
-		  (push (match-string-no-properties 0) stretches)))
-	      (apply 'concat (nreverse stretches))))
-
+		
 	   (t
 	    ;; Normal function or initializer.
 	    (when (c-syntactic-re-search-forward "[{(]" nil t)
@@ -1856,7 +1836,7 @@ with a brace block."
   ;; Return a cons of the beginning and end positions of the current
   ;; top level declaration or macro.  If point is not inside any then
   ;; nil is returned, unless NEAR is non-nil in which case the closest
-  ;; following one is chosen instead (if there is any).  The end
+  ;; following one is chosen instead (if there is any).	 The end
   ;; position is at the next line, providing there is one before the
   ;; declaration.
   ;;
@@ -1867,104 +1847,104 @@ with a brace block."
 	(c-narrow-to-most-enclosing-decl-block t)  ; e.g. class, namespace
 	(or (save-restriction
 	      (c-narrow-to-most-enclosing-decl-block nil)
-
-    ;; Note: Some code duplication in `c-beginning-of-defun' and
-    ;; `c-end-of-defun'.
-    (catch 'exit
-      (let ((start (point))
-	    (paren-state (c-parse-state))
-	    lim pos end-pos)
-	(unless (c-safe
-		  (goto-char (c-least-enclosing-brace paren-state))
+      
+	      ;; Note: Some code duplication in `c-beginning-of-defun' and
+	      ;; `c-end-of-defun'.
+	      (catch 'exit
+		(let ((start (point))
+		      (paren-state (c-parse-state))
+		      lim pos end-pos)
+		  (unless (c-safe
+			    (goto-char (c-least-enclosing-brace paren-state))
 			    ;; If we moved to the outermost enclosing paren
 			    ;; then we can use c-safe-position to set the
 			    ;; limit. Can't do that otherwise since the
 			    ;; earlier paren pair on paren-state might very
 			    ;; well be part of the declaration we should go
 			    ;; to.
-		  (setq lim (c-safe-position (point) paren-state))
-		  t)
-	  ;; At top level.  Make sure we aren't inside a literal.
-	  (setq pos (c-literal-limits
-		     (c-safe-position (point) paren-state)))
-	  (if pos (goto-char (car pos))))
-
-	(when (c-beginning-of-macro)
-	  (throw 'exit
-		 (cons (point)
-		       (save-excursion
-			 (c-end-of-macro)
-			 (forward-line 1)
-			 (point)))))
-
-	(setq pos (point))
-	(when (or (eq (car (c-beginning-of-decl-1 lim)) 'previous)
-		  (= pos (point)))
-	  ;; We moved back over the previous defun.  Skip to the next
-	  ;; one.  Not using c-forward-syntactic-ws here since we
-	  ;; should not skip a macro.  We can also be directly after
-	  ;; the block in a `c-opt-block-decls-with-vars-key'
-	  ;; declaration, but then we won't move significantly far
-	  ;; here.
-	  (goto-char pos)
-	  (c-forward-comments)
-
-	  (when (and near (c-beginning-of-macro))
-	    (throw 'exit
-		   (cons (point)
-			 (save-excursion
-			   (c-end-of-macro)
-			   (forward-line 1)
-			   (point))))))
-
-	(if (eobp) (throw 'exit nil))
-
-	;; Check if `c-beginning-of-decl-1' put us after the block in a
-	;; declaration that doesn't end there.  We're searching back and
-	;; forth over the block here, which can be expensive.
-	(setq pos (point))
-	(if (and c-opt-block-decls-with-vars-key
-		 (progn
-		   (c-backward-syntactic-ws)
-		   (eq (char-before) ?}))
-		 (eq (car (c-beginning-of-decl-1))
-		     'previous)
-		 (save-excursion
-		   (c-end-of-decl-1)
-		   (and (> (point) pos)
-			(setq end-pos (point)))))
-	    nil
-	  (goto-char pos))
-
-	(if (and (not near) (> (point) start))
-	    nil
+			    (setq lim (c-safe-position (point) paren-state))
+			    t)
+		    ;; At top level.  Make sure we aren't inside a literal.
+		    (setq pos (c-literal-limits
+			       (c-safe-position (point) paren-state)))
+		    (if pos (goto-char (car pos))))
+
+		  (when (c-beginning-of-macro)
+		    (throw 'exit
+			   (cons (point)
+				 (save-excursion
+				   (c-end-of-macro)
+				   (forward-line 1)
+				   (point)))))
 
-	  ;; Try to be line oriented; position the limits at the
-	  ;; closest preceding boi, and after the next newline, that
-	  ;; isn't inside a comment, but if we hit a neighboring
-	  ;; declaration then we instead use the exact declaration
-	  ;; limit in that direction.
-	  (cons (progn
 		  (setq pos (point))
-		  (while (and (/= (point) (c-point 'boi))
-			      (c-backward-single-comment)))
-		  (if (/= (point) (c-point 'boi))
-		      pos
-		    (point)))
-		(progn
-		  (if end-pos
-		      (goto-char end-pos)
-		    (c-end-of-decl-1))
+		  (when (or (eq (car (c-beginning-of-decl-1 lim)) 'previous)
+			    (= pos (point)))
+		    ;; We moved back over the previous defun.  Skip to the next
+		    ;; one.  Not using c-forward-syntactic-ws here since we
+		    ;; should not skip a macro.  We can also be directly after
+		    ;; the block in a `c-opt-block-decls-with-vars-key'
+		    ;; declaration, but then we won't move significantly far
+		    ;; here.
+		    (goto-char pos)
+		    (c-forward-comments)
+
+		    (when (and near (c-beginning-of-macro))
+		      (throw 'exit
+			     (cons (point)
+				   (save-excursion
+				     (c-end-of-macro)
+				     (forward-line 1)
+				     (point))))))
+
+		  (if (eobp) (throw 'exit nil))
+
+		  ;; Check if `c-beginning-of-decl-1' put us after the block in a
+		  ;; declaration that doesn't end there.	We're searching back and
+		  ;; forth over the block here, which can be expensive.
 		  (setq pos (point))
-		  (while (and (not (bolp))
-			      (not (looking-at "\\s *$"))
-			      (c-forward-single-comment)))
-		  (cond ((bolp)
-			 (point))
-			((looking-at "\\s *$")
-			 (forward-line 1)
-			 (point))
-			(t
+		  (if (and c-opt-block-decls-with-vars-key
+			   (progn
+			     (c-backward-syntactic-ws)
+			     (eq (char-before) ?}))
+			   (eq (car (c-beginning-of-decl-1))
+			       'previous)
+			   (save-excursion
+			     (c-end-of-decl-1)
+			     (and (> (point) pos)
+				  (setq end-pos (point)))))
+		      nil
+		    (goto-char pos))
+
+		  (if (and (not near) (> (point) start))
+		      nil
+
+		    ;; Try to be line oriented; position the limits at the
+		    ;; closest preceding boi, and after the next newline, that
+		    ;; isn't inside a comment, but if we hit a neighboring
+		    ;; declaration then we instead use the exact declaration
+		    ;; limit in that direction.
+		    (cons (progn
+			    (setq pos (point))
+			    (while (and (/= (point) (c-point 'boi))
+					(c-backward-single-comment)))
+			    (if (/= (point) (c-point 'boi))
+				pos
+			      (point)))
+			  (progn
+			    (if end-pos
+				(goto-char end-pos)
+			      (c-end-of-decl-1))
+			    (setq pos (point))
+			    (while (and (not (bolp))
+					(not (looking-at "\\s *$"))
+					(c-forward-single-comment)))
+			    (cond ((bolp)
+				   (point))
+				  ((looking-at "\\s *$")
+				   (forward-line 1)
+				   (point))
+				  (t
 				   pos))))))))
 	    (and (not near)
 		 (goto-char (point-min))
@@ -1978,11 +1958,13 @@ If point is not inside any then the clos
 chosen.  Each successive call of this command extends the marked
 region by one function.
 
-A mark is left where the command started, unless the region is already active
-\(in Transient Mark mode).
+A mark is left where the command started.
 
 As opposed to \\[c-beginning-of-defun] and \\[c-end-of-defun], this
 function does not require the declaration to contain a brace block."
+  ;; Middle sentence of doc-string was: A mark is left where the command
+  ;; started, unless the region is already active \(in Transient Mark mode).
+  ;; FIXME!!!  for transient-mark/zemacs sometime.  (2012-03-08.)
   (interactive)
 
   (let (decl-limits case-fold-search)
@@ -2000,7 +1982,9 @@ function does not require the declaratio
 		   (eq last-command 'c-mark-function)))
 	     (push-mark-p (and (eq this-command 'c-mark-function)
 			       (not extend-region-p)
-			       (not (and transient-mark-mode mark-active)))))
+			       ;; (not (and transient-mark-mode mark-active))
+			       ;; FIXME!!!, sometime (2012-03-08.)
+			       )))
 	(if push-mark-p (push-mark (point)))
 	(if extend-region-p
 	    (progn
@@ -2027,7 +2011,7 @@ function does not require the declaratio
 
 ;; Movement by statements.
 (defun c-in-comment-line-prefix-p ()
-  ;; Point is within a comment.  Is it also within a comment-prefix?
+  ;; Point is within a comment.	 Is it also within a comment-prefix?
   ;; Space at BOL which precedes a comment-prefix counts as part of it.
   ;;
   ;; This function might do hidden buffer changes.
